#define _GNU_SOURCE
#include<stdio.h>
#include<stdlib.h>
#include<math.h>

/* Description:
Generate all text for large e numbers

adjust:
 - string length
 - font
 - yposition

*/

	double ColPosition,RowPosition;


int main()
{

	int nCurrentRow;
	int nCurrentCharInRow;
	int nCurrentCharInString=0;
	int nLastCharInString;
	float fFontSize;	//font size which changes for each row.

	//settings
	int nLastRow = 12;	//Number of rows to print.
	int nLength = 7;	//Initial length of e characters for first row.
	float fYPosition=24.0;	//Initial height of first row from bottom of the poster
	float fLengthRatio = 1.3;	//Ratio of changing row-length, font-size, Y-Position from top to bottom of poster


	FILE *fp;
	char * line = NULL;
	size_t len = 0;
	ssize_t read;

	//Read in one line of the extra long e string for processing later.
	//code snippet from: man getline
	fp = fopen("fixedprimes.txt","r");
	if (fp == NULL)
		exit(EXIT_FAILURE);
	read = getline(&line, &len, fp);
	//printf("Retrieved line of length %zu :\n", read);
	//printf("%s", line);
	fclose(fp);

	for ( nCurrentRow= 1; nCurrentRow<=nLastRow ; nCurrentRow += 1){

		//Calculate font size to fit characters into width of row.
		//fFontSize = 2800.0 / nLength - (nLength*.01);
		fFontSize = 2800.0 / nLength;
	
		printf("\\rput[t]{0}(10.25,%.2f in){\\textcolor{foretext}{\\changefont{%.3f pt}",fYPosition,fFontSize);
	
		nLastCharInString = 10;
	
		for ( nCurrentCharInRow= 1; nCurrentCharInRow<=nLength ; nCurrentCharInRow += 1){
			//if the last character is a space then remove it.
			if ((nCurrentCharInRow==nLength) && (strncmp(&line[nCurrentCharInString]," ",1)==0)){
			//if ((nCurrentCharInRow==nLength)){
				printf("");
			}
			else{
				printf("%c",line[nCurrentCharInString]);
			}
			//Point to the next character in the string.
			nCurrentCharInString += 1;
		}
		
		//if this character is a space then remove it.
		if (strncmp(&line[nCurrentCharInString]," ",1)==0){
			nCurrentCharInString += 1;
		}
		//Check if previous character was a space, do nothing.
		else if (strncmp(&line[nCurrentCharInString-1]," ",1)==0){
		}
		//Check if this character is not a space.
		else if (strncmp(&line[nCurrentCharInString]," ",1)!=0){
			//keep reading until end of word
			while (strncmp(&line[nCurrentCharInString]," ",1)){
				printf("%c",line[nCurrentCharInString]);
				nCurrentCharInString += 1;
			}
			//get rid of space that would have shown up at the beginning of the next line.
			nCurrentCharInString += 1;
		}

		//Print remaining characters of line.
		printf("}}\n");
	
		//Determine new length of string for next iteration
		nLength = nLength*fLengthRatio;
	
		//Determine new Y-Position for next line
		fYPosition = fYPosition - fFontSize/74.0;

	}

	if (line)
		free(line);
	return EXIT_SUCCESS;


}
